KERN_REBOOT(9)

NAME
kern_reboot - halt or reboot the system

SYNOPSIS
#include <sys/types.h>
#include <sys/systm.h>
#include <sys/reboot.h>
void
kern_reboot(int howto);
#include <sys/eventhandler.h>
EVENTHANDLER_REGISTER(shutdown_pre_sync, shutdown_fn, private, priority);
EVENTHANDLER_REGISTER(shutdown_post_sync, shutdown_fn, private, priority);
EVENTHANDLER_REGISTER(shutdown_final, shutdown_fn, private, priority);

DESCRIPTION
The kern_reboot() function handles final system shutdown, and either halts or reboots the system. The exact action to be taken is determined by the flags passed in howto and by whether or not the system has finished autoconfiguration.

If the system has finished autoconfiguration, kern_reboot() does the following:

1.  If this is the first invocation of kern_reboot() and the RB_NOSYNC flag is not set in howto, syncs and unmounts the system disks by calling vfs_unmountall(9).

2.  Disables interrupts.

3.  If rebooting after a crash (i.e., if RB_DUMP is set in howto, but RB_HALT is not), saves a system crash dump.

4.  Runs any shutdown hooks previously registered.

5.  Prints a message indicating that the system is about to be halted or rebooted.

6.  If RB_HALT is set in howto, halts the system. Otherwise, reboots the system.

If the system has not finished autoconfiguration, kern_reboot() runs any shutdown hooks previously registered, prints a message, and halts the system.

RETURN VALUES
The kern_reboot() function does not return.

SEE ALSO
reboot(2) EVENTHANDLER(9) vfs_unmountall(9)